﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Ro.CF.Communication;

namespace Demo
{
    public partial class FRM_Sandbox : Form
    {
        private S7Connector.Base SPS;
        private S7Connector.TypeSeries TCP_Selected_SPSType;
        
        private System.IO.Ports.StopBits MPI_Selected_Stopbits;
        private System.IO.Ports.Parity MPI_Selected_Parity;

        private System.IO.Ports.StopBits PPI_Selected_Stopbits;
        private System.IO.Ports.Parity PPI_Selected_Parity;

        private S7Connector.DataTypes Read_Selected_DataType;
        private S7Connector.MemmoryTypes Read_Selected_MemmoryType;

        public int testint;
        public FRM_Sandbox()
        {
            InitializeComponent();
        }

        private void FRM_Sandbox_Load(object sender, EventArgs e)
        {
            //S7Connector.Licence = "Ihre Lizenz";

            CB_SPS_Type_TCP.DataSource = Enum.GetValues(typeof(S7Connector.TypeSeries));
            CB_SPS_Type_TCP.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_SPS_Type_TCP.SelectedIndex = 0;

            CB_MemmoryType_Read.DataSource = Enum.GetValues(typeof(S7Connector.MemmoryTypes));
            CB_MemmoryType_Read.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_MemmoryType_Read.SelectedIndex = 0;

            CB_Port_MPI.DataSource = System.IO.Ports.SerialPort.GetPortNames();
            CB_Port_MPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Port_MPI.SelectedIndex = 0;

            CB_Stopbits_MPI.DataSource = Enum.GetValues(typeof(System.IO.Ports.StopBits));
            CB_Stopbits_MPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Stopbits_MPI.SelectedIndex = 1;

            CB_Parity_MPI.DataSource = Enum.GetValues(typeof(System.IO.Ports.Parity));
            CB_Parity_MPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Parity_MPI.SelectedIndex = 1;

            CB_Port_PPI.DataSource = System.IO.Ports.SerialPort.GetPortNames();
            CB_Port_PPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Port_PPI.SelectedIndex = 0;

            CB_Stopbits_PPI.DataSource = Enum.GetValues(typeof(System.IO.Ports.StopBits));
            CB_Stopbits_PPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Stopbits_PPI.SelectedIndex = 1;

            CB_Parity_PPI.DataSource = Enum.GetValues(typeof(System.IO.Ports.Parity));
            CB_Parity_PPI.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_Parity_PPI.SelectedIndex = 2;

            CB_DataType_Read.DataSource = Enum.GetValues(typeof(S7Connector.DataTypes));
            CB_DataType_Read.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_DataType_Read.SelectedIndex = 1;
        }

        private void BTN_MPI_Init_Click(object sender, EventArgs e)
        {
            try
            {
                SPS = new S7Connector.MPI(CB_Port_MPI.Text, Convert.ToInt32(TB_TimeOut_MPI.Text), Convert.ToInt32(TB_Baud_MPI.Text), Convert.ToInt32(TB_Databits_MPI.Text), MPI_Selected_Stopbits, MPI_Selected_Parity, Convert.ToByte(TB_Address_PG_MPI.Text), Convert.ToByte(TB_Address_AG_MPI.Text));
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_TCP_Init_Click(object sender, EventArgs e)
        {
            try
            {
                SPS = new S7Connector.TCPIP(TB_IP_Address_TCP.Text, Convert.ToInt32(TB_Port_TCP.Text), Convert.ToInt32(TB_TimeOut_TCP.Text), TCP_Selected_SPSType);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void CB_Stopbits_MPI_SelectedIndexChanged(object sender, EventArgs e)
        {
            MPI_Selected_Stopbits = (System.IO.Ports.StopBits)CB_Stopbits_MPI.SelectedValue;
        }

        private void CB_Parity_MPI_SelectedIndexChanged(object sender, EventArgs e)
        {
            MPI_Selected_Parity = (System.IO.Ports.Parity)CB_Parity_MPI.SelectedValue;
        }

        private void BTN_Read_Click(object sender, EventArgs e)
        {
            try
            {
                short DBNr = Convert.ToInt16(TB_DBNr_Read.Text);
                short Count = Convert.ToInt16(TB_Count_Read.Text);
                int Start = Convert.ToInt32(TB_StartAddress_Read.Text);

                object Result = SPS.AG_Read(DBNr, Start, Count, Read_Selected_DataType, Read_Selected_MemmoryType);
                LB_Result.Items.Clear();
                for (int i = 0; i < (Result as Array).Length; i++)
                    LB_Result.Items.Add("VAL" + i.ToString("0000") + " = " + (Result as Array).GetValue(i).ToString());
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void CB_MemmoryType_Read_SelectedIndexChanged(object sender, EventArgs e)
        {
            Read_Selected_MemmoryType = (S7Connector.MemmoryTypes)CB_MemmoryType_Read.SelectedValue;

            if (CB_MemmoryType_Read.SelectedIndex == 0)
            {
                TB_DBNr_Read.Enabled = true;
            }
            else
            {
                TB_DBNr_Read.Text = "0";
                TB_DBNr_Read.Enabled = false;
            }
        }

        private void CB_DataType_Read_SelectedIndexChanged(object sender, EventArgs e)
        {
            Read_Selected_DataType = (S7Connector.DataTypes)CB_DataType_Read.SelectedValue;
        }

        private void BTN_Write_Click(object sender, EventArgs e)
        {
            try
            {
                short DBNr = Convert.ToInt16(TB_DBNr_Read.Text);
                short Count = Convert.ToInt16(TB_Count_Read.Text);
                int Start = Convert.ToInt32(TB_StartAddress_Read.Text);

                switch (CB_DataType_Read.Text)
                {
                    case "BYTE":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new byte[] { Convert.ToByte(TB_Value.Text) });
                        break;
                    case "WORD":
                    case "DATE":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new UInt16[] { Convert.ToUInt16(TB_Value.Text) });
                        break;
                    case "INT":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new Int16[] { Convert.ToInt16(TB_Value.Text) });
                        break;
                    case "REAL":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new float[] { float.Parse(TB_Value.Text) });
                        break;
                    case "DWORD":
                    case "TIME_OF_DAY":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new UInt32[] { Convert.ToUInt32(TB_Value.Text) });
                        break;
                    case "S5TIME":
                        S7Connector.S5Time[] s5Times = new S7Connector.S5Time[2];
                        s5Times[0] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 10, 0));
                        s5Times[1] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 11, 0));
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s5Times);
                        break;
                    case "TIMEIEC32":
                        S7Connector.TimeIEC32[] s7Times = new S7Connector.TimeIEC32[1];
                        s7Times[0] = new S7Connector.TimeIEC32(new TimeSpan(0, 0, 2, 1, 100));
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s7Times);
                        break;
                    case "COUNTER":
                         S7Connector.Counter[] s7Conter= new S7Connector.Counter[1];
                         s7Conter[0] = new S7Connector.Counter(Convert.ToInt16(TB_Value.Text));
                         SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s7Conter);
                        break;
                    case "BOOL":
                        bool Val = false;
                        if (TB_Value.Text.ToLower() == "true")
                            Val = true;
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, Val);
                        break;
                }
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }

        private void TB_TimeOut_MPI_TextChanged(object sender, EventArgs e)
        {

        }

        private void TB_Databits_MPI_TextChanged(object sender, EventArgs e)
        {

        }

        private void TB_Address_AG_MPI_TextChanged(object sender, EventArgs e)
        {

        }

        private void CB_Stopbits_PPI_SelectedIndexChanged(object sender, EventArgs e)
        {
            PPI_Selected_Stopbits = (System.IO.Ports.StopBits)CB_Stopbits_PPI.SelectedValue;
        }

        private void CB_Parity_PPI_SelectedIndexChanged(object sender, EventArgs e)
        {
          PPI_Selected_Parity = (System.IO.Ports.Parity)CB_Parity_PPI.SelectedValue;
        }

        private void BTN_S7Online_close_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.Close();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_Read_Clock_Click(object sender, EventArgs e)
        {
            try
            {
                LB_Result.Items.Clear();
                DateTime spstime = SPS.PG_ClockRead();
                DTP_Clock.Value = spstime;
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }  
        }

        private void btn_Read_Blocks_Click(object sender, EventArgs e)
        {
            
          try
            {
                LB_Blocks.Items.Clear();
                int[] Blocklist;

                Blocklist = SPS.PG_BlockList(S7Connector.BlockTypes.FC);
                foreach (int I in Blocklist)
                    LB_Blocks.Items.Add("FC" + I.ToString());

                Blocklist = SPS.PG_BlockList(S7Connector.BlockTypes.DB);
                foreach (int I in Blocklist)
                    LB_Blocks.Items.Add("DB" + I.ToString());

                Blocklist = SPS.PG_BlockList(S7Connector.BlockTypes.FB);
                foreach (int I in Blocklist)
                    LB_Blocks.Items.Add("FB" + I.ToString());

                Blocklist = SPS.PG_BlockList(S7Connector.BlockTypes.OB);
                foreach (int I in Blocklist)
                    LB_Blocks.Items.Add("OB" + I.ToString());
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }    
        }

        private void BTN_RunMode_Click(object sender, EventArgs e)
        {
            try
            {
                TB_Runmode.Text = ((SPS.PG_RunMode()) ? "Run" : "Stop");
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_Write_Clock_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.PG_ClockWrite(DTP_Clock.Value);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }   
        }

        private void BTN_Start_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.PG_Start();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
                
        }

        private void BTN_Stop_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("You are about to stop the cpu.\nProceed?", "Stop CPU", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    SPS.PG_Stop();
                }
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_PPI_Init_Click(object sender, EventArgs e)
        {
            try
            {
                SPS = new S7Connector.PPI(CB_Port_PPI.Text, Convert.ToInt32(TB_TimeOut_PPI.Text), Convert.ToInt32(TB_Baud_PPI.Text), Convert.ToInt32(TB_Databits_PPI.Text), PPI_Selected_Stopbits, PPI_Selected_Parity, Convert.ToByte(TB_Address_PG_PPI.Text), Convert.ToByte(TB_Address_AG_PPI.Text));
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

       

        private void CB_SPS_Type_TCP_SelectedIndexChanged(object sender, EventArgs e)
        {
            TCP_Selected_SPSType = (S7Connector.TypeSeries)CB_SPS_Type_TCP.SelectedValue;
        }

        private void CB_Port_MPI_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void BTN_TCP_Close_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.Close();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }

        }

        private void BTN_MPI_Close_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.Close();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_PPI_Close_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.Close();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void BTN_Compress_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.PG_Compress();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
            
        }

        private void BTN_GeneralReset_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("Are You Sure?", "General Reset", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    SPS.PG_GeneralReset();
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }  
        }

        private void btn_Read_Block_Click(object sender, EventArgs e)
        {
            try{

                byte[] block_result;
                string test;
                string fdb;
                string fnr;
                int blocknr;


                S7Connector.BlockTypes blocktype;

                test = LB_Blocks.Text;
                fdb = test.Substring(0, 2);
                fnr = test.Substring(2);
                blocknr = Convert.ToInt32(fnr);

                switch (fdb)
                {
                    case "DB":
                        blocktype = S7Connector.BlockTypes.DB;
                        break;
                    case "OB":
                        blocktype = S7Connector.BlockTypes.OB;
                        break;
                    case "FB":
                        blocktype = S7Connector.BlockTypes.FB;
                        break;
                    case "FC":
                        blocktype = S7Connector.BlockTypes.FC;
                        break;
                    case "SDB":
                        blocktype = S7Connector.BlockTypes.SDB;
                        break;
                    case "SFB":
                        blocktype = S7Connector.BlockTypes.SFB;
                        break;
                    case "SFC":
                        blocktype = S7Connector.BlockTypes.SFC;
                        break;
                    default:
                        blocktype = S7Connector.BlockTypes.SFC;
                        break;
                }

                block_result = SPS.PG_BlockRead(blocktype, blocknr);
                LB_Blocks.Items.Clear();

                 //row Code
                 for (int i = 0; i < (block_result as Array).Length; i++)
                 LB_Blocks.Items.Add(block_result[i]);
            }
            catch (Exception E)
            {
                //MessageBox.Show(E.StackTrace.ToString());
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void SC_Errors_Panel2_Paint(object sender, PaintEventArgs e)
        {

        }

        private void FLP_Init_Paint(object sender, PaintEventArgs e)
        {

        }

        private void btn_Del_Block_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] block_result;
                string test;
                string fdb;
                string fnr;
                int blocknr;

                S7Connector.BlockTypes blocktype;

                test = LB_Blocks.Text;
                fdb = test.Substring(0, 2);
                fnr = test.Substring(2);
                blocknr = Convert.ToInt32(fnr);
                
                switch (fdb)
                {
                    case "DB":
                        blocktype = S7Connector.BlockTypes.DB; 
                        break;
                    case "OB":
                        blocktype = S7Connector.BlockTypes.OB;
                        break;
                    case "FB":
                        blocktype = S7Connector.BlockTypes.FB;
                        break;
                    case "FC":
                        blocktype = S7Connector.BlockTypes.FC;
                        break;
                    case "SDB":
                        blocktype = S7Connector.BlockTypes.SDB;
                        break;
                    case "SFB":
                        blocktype = S7Connector.BlockTypes.SFB;
                        break;
                    case "SFC":
                        blocktype = S7Connector.BlockTypes.SFC;
                        break;
                    default:
                        blocktype = S7Connector.BlockTypes.SFC;
                        break;
                }
            

                if (MessageBox.Show("Are You Sure?", "Block Delete", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    block_result = SPS.PG_BlockDelete(blocktype, blocknr);
                    LB_Blocks.Items.Clear();
                }
            }
            catch (Exception E)
            {
                //MessageBox.Show(E.StackTrace.ToString());
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void btn_Write_Block_Click(object sender, EventArgs e)
        {
            try
            {
                byte[] block_result;

                byte[] mcs7code = new byte[] { 112, 112, 1, 1, 2, 12, 0, 1, 0, 0, 0, 92, 0, 0, 0, 0, 3, 144, 215, 128, 37, 65, 3, 143, 195, 174, 37, 65, 0, 8, 0, 6, 0, 0, 0, 6, 192, 0, 152, 200, 101, 0, 1, 1, 0, 0, 0, 0, 0, 5, 1, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 238, 149, 0, 0, 0, 0, 0, 0, 0, 0 };
                if (MessageBox.Show("Are You Sure? Write FC1 : E0.0 = M200.0 ", "Block Delete", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    block_result = SPS.PG_BlockWrite(mcs7code);
                    LB_Blocks.Items.Clear();
                }
            }
            catch (Exception E)
            {
                //MessageBox.Show(E.StackTrace.ToString());
                LB_Errors.Items.Add(E.ToString());
            }
        
        }

        private void TB_IP_Address_TCP_TextChanged(object sender, EventArgs e)
        {

        }


            

            
  

        private void button1_Click_1(object sender, EventArgs e)
        {
           //byte[] MCS7CODE;
           //LibNoDaveConnectionLibrary.MC7.MC7Converter.GetAWLBlock(MCS7CODE, 1);
           

        }

        private void button1_Click_2(object sender, EventArgs e)
        {

        }

        private void btn_diag_Click(object sender, EventArgs e)
        {
            try
            {
                /*
                //object Result = SPS.PG_SZLInfo(273, 6); //Baisi Hardware
                //object Result = SPS.PG_SZLInfo(273, 6); //Baisi Firmware
                //object Result = SPS.PG_SZLInfo(25, 0);// Led
                //object Result = SPS.PG_SZLInfo(562, 4);// schalter
                //object Result = SPS.PG_SZLInfo(160, 0); //Diagnose

                byte[] buffer;

                int[] E_ID = new int[200];
                DateTime[] time = new DateTime[200];
                string[] Message = new string[200];

                buffer = SPS.PG_SZLInfo(160, 0); // Diagnose
                int lcount = 0; 
                for (int I = 0; I <= 5; I++)
                {
                    byte hi = buffer[17 + lcount];
                    byte lo = buffer[16 + lcount];
                    byte[] s7time = new byte[] { buffer[27 + lcount], buffer[28 + lcount], buffer[29 + lcount], buffer[30 + lcount], buffer[31 + lcount], buffer[32 + lcount], buffer[33 + lcount], buffer[34 + lcount], buffer[35 + lcount] };

                    Message[I] = S7Connector.Base.GetdiagnosticItem(lo, hi);
                    E_ID[I]= Convert.ToInt16(lo * 256 + hi);
                    time[I] = S7Connector.Base.DataToDateTime(s7time);
                    lcount = lcount + 20;
                }

                LB_Blocks.Items.Clear();
                for (int I = 0; I < 5; I++)
                    LB_Blocks.Items.Add(Convert.ToString(time[I]) + " " + Convert.ToString(E_ID[I]) + " " + Message[I]);


                // for (int i = 0; i < (Result as Array).Length; i++)
                //     LB_Blocks.Items.Add("VAL" + i.ToString("0000") + " = " + (Result as Array).GetValue(i));
                //LB_Blocks.Items.Add("VAL" + i.ToString("0000") + " = " + Convert.ToChar((Result as Array).GetValue(i)));
            */
             }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] Val_b = new byte[1];
            Val_b[0] = 0;

            try
            {
                object Result  = SPS.AG_Read(200, 0, 1, S7Connector.DataTypes.BYTE, S7Connector.MemmoryTypes.Datablock);
                
                Val_b[0] = Convert.ToByte ((Result as Array).GetValue(0));
                Val_b[0]++;

                SPS.AG_Write(200, 0, S7Connector.MemmoryTypes.Datablock, Val_b);

                if (Val_b[0] == 255)
                {
                    timer1.Enabled = false;
                    MessageBox.Show("Test OK");
                }
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
                
            }
        }

        private void btm_test_bytes_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            byte[] Val_b = (new byte[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 100, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 150, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 200, 1, 2});

            try
            {
                SPS.AG_Write(200, 0, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            timer2.Enabled = true;
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            byte[] Val_b = new byte[1];
            Val_b[0] = 0;

            try
            {
                object Result = SPS.AG_Read(200, 0, 1, S7Connector.DataTypes.BYTE, S7Connector.MemmoryTypes.Datablock);

                Val_b[0] = Convert.ToByte((Result as Array).GetValue(0));
                Val_b[0]++;
                testint++;
                SPS.AG_Write(200, testint, S7Connector.MemmoryTypes.Datablock, Val_b);

                if (Val_b[0] == 255)
                {
                    Val_b[0] = 0;
                }
                if (testint == 15999)
                {
                    timer2.Enabled = false;
                    MessageBox.Show("Test OK");
                }
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
           
            try
            {
                SPS.AG_Write(200, 15, S7Connector.MemmoryTypes.Datablock, true);
 
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.AG_Write(200, 8, S7Connector.MemmoryTypes.Datablock, true);

            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.AG_Write(200, 8, S7Connector.MemmoryTypes.Datablock, false);

            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {

        }

        private void button7_Click_1(object sender, EventArgs e)
        {
            Int16[] Val_b = (new Int16[] {20765});

            try
            {
                SPS.AG_Write(200, 10, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Int16[] Val_b = (new Int16[] { -20765 });

            try
            {
                SPS.AG_Write(200, 12, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            byte[] Val_b = (new byte[] { 123 });

            try
            {
                SPS.AG_Write(200, 10, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            byte[] Val_b = (new byte[] { 123 });

            try
            {
                SPS.AG_Write(200, 11, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            Int16[] Val_b = (new Int16[] { 16 });

            try
            {
                SPS.AG_Write(200, 14, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            UInt16[] Val_b = (new UInt16[] {64768 });

            try
            {
                SPS.AG_Write(200, 16, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            UInt16[] Val_b = (new UInt16[] { 1,2,3,4,5,6,7,8,9,10});

            try
            {
                SPS.AG_Write(200, 18, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button14_Click(object sender, EventArgs e)
        {
            UInt32[] Val_b = (new UInt32[] { 1220765 });

            try
            {
                SPS.AG_Write(200, 20, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button15_Click(object sender, EventArgs e)
        {
            float[] Val_b = (new float[] { 0.98543f, -12.00f, 625245.0f });

            try
            {
                SPS.AG_Write(200, 20, S7Connector.MemmoryTypes.Datablock, Val_b);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button16_Click(object sender, EventArgs e)
        {
            //DB200.DBW30 s5t#1s,s5t#2s,s5t#3s,s5t#400ms
   
            try
            {
                        S7Connector.S5Time[] s5Times = new S7Connector.S5Time[4];
                        s5Times[0] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 1, 0));
                        s5Times[1] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 2, 0));
                        s5Times[2] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 3, 0));
                        s5Times[3] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 0, 400));
                        SPS.AG_Write(200, 30, S7Connector.MemmoryTypes.Datablock, s5Times);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button17_Click(object sender, EventArgs e)
        {
            //DB200.DBW30 s5t#1s,s5t#2s,s5t#3s,s5t#400ms

            try
            {
                S7Connector.S5Time[] s5Times = new S7Connector.S5Time[4];
                s5Times[0] = new S7Connector.S5Time(new TimeSpan(0, 0, 12, 0, 0));
                s5Times[1] = new S7Connector.S5Time(new TimeSpan(0, 0, 16, 10, 0));
                s5Times[2] = new S7Connector.S5Time(new TimeSpan(0, 0, 9, 1, 0));
                s5Times[3] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 0, 400));
                SPS.AG_Write(0, 100, S7Connector.MemmoryTypes.Timer, s5Times);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }
        }

        private void button18_Click(object sender, EventArgs e)
        {
            try
            {
            S7Connector.Counter[] s7Conter = new S7Connector.Counter[4];
            s7Conter[0] = new S7Connector.Counter(Convert.ToInt16(6));
            s7Conter[1] = new S7Connector.Counter(Convert.ToInt16(12));
            s7Conter[2] = new S7Connector.Counter(Convert.ToInt16(200));
            s7Conter[3] = new S7Connector.Counter(Convert.ToInt16(900));
            SPS.AG_Write(0, 50, S7Connector.MemmoryTypes.Counter, s7Conter);
            } 
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());

            }  
        }

        private void button19_Click(object sender, EventArgs e)
        {
            try
            {
                SPS.AG_Write(0, 806, S7Connector.MemmoryTypes.Output, true);
                SPS.AG_Write(0, 806, S7Connector.MemmoryTypes.Input, true);
                SPS.AG_Write(0, 806, S7Connector.MemmoryTypes.Flag, true);
            }
            catch (Exception E)
            {
                LB_Errors.Items.Add(E.ToString());
            }
        }

    }
}
