﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Ro.CF.Communication;

namespace SmartDeviceProject
{
    public partial class Form1 : Form
    {
        private S7Connector.Base SPS;
        private S7Connector.TypeSeries TCP_Selected_SPSType;

        private S7Connector.DataTypes Read_Selected_DataType;
        private S7Connector.MemmoryTypes Read_Selected_MemmoryType;

        public Form1()
        {
            InitializeComponent();
        }

        private void BTN_TCP_Close_Click(object sender, EventArgs e)
        {

        }

        private void CB_SPS_Type_TCP_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void TB_IP_Address_TCP_TextChanged(object sender, EventArgs e)
        {

        }

        private void BTN_TCP_Init_Click(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            S7Connector.Licence = "nur Demo";

            //CB_SPS_Type_TCP.DataSource = Enum.GetValues(typeof(S7Connector.TypeSeries));
            
            CB_SPS_Type_TCP.Items.Add(S7Connector.TypeSeries.S71200);
            CB_SPS_Type_TCP.Items.Add(S7Connector.TypeSeries.S7200);
            CB_SPS_Type_TCP.Items.Add(S7Connector.TypeSeries.S7300);
            CB_SPS_Type_TCP.Items.Add(S7Connector.TypeSeries.S7400);

            CB_SPS_Type_TCP.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_SPS_Type_TCP.SelectedIndex = 1;

            CB_DataType_Read.Items.Add(S7Connector.DataTypes.BOOL);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.BYTE);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.WORD);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.CHAR);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.COUNTER);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.DATE);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.DWORD);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.INT);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.REAL);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.S5TIME);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.TIME_OF_DAY);
            CB_DataType_Read.Items.Add(S7Connector.DataTypes.TIMEIEC32);

            CB_DataType_Read.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_DataType_Read.SelectedIndex = 1;

            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Counter);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Datablock);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Flag);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Input);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.InstanceDatablock);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.LocalData);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Localdataofpreviousblock);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Output);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Periphery);
            CB_MemmoryType_Read.Items.Add(S7Connector.MemmoryTypes.Timer);

            CB_MemmoryType_Read.DropDownStyle = ComboBoxStyle.DropDownList;
            CB_MemmoryType_Read.SelectedIndex = 1;
        }

        private void BTN_TCP_Init_Click_1(object sender, EventArgs e)
        {
            try
            {
                SPS = new S7Connector.TCPIP(TB_IP_Address_TCP.Text, Convert.ToInt32(TB_Port_TCP.Text), Convert.ToInt32(TB_TimeOut_TCP.Text), TCP_Selected_SPSType);
            }
            catch (Exception E)
            {
               MessageBox.Show(E.ToString());
            }
        }

        private void BTN_Write_Click(object sender, EventArgs e)
        {

        }

        private void CB_MemmoryType_Read_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void CB_DataType_Read_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void BTN_Read_Click(object sender, EventArgs e)
        {

        }

        private void BTN_Read_Click_1(object sender, EventArgs e)
        {
            try
            {
                short DBNr = Convert.ToInt16(TB_DBNr_Read.Text);
                short Count = Convert.ToInt16(TB_Count_Read.Text);
                int Start = Convert.ToInt32(TB_StartAddress_Read.Text);

                object Result = SPS.AG_Read(DBNr, Start, Count, Read_Selected_DataType, Read_Selected_MemmoryType);
                LB_Result.Items.Clear();
                for (int i = 0; i < (Result as Array).Length; i++)
                    LB_Result.Items.Add("VAL" + i.ToString("0000") + " = " + (Result as Array).GetValue(i).ToString());
            }
            catch (Exception E)
            {
                MessageBox.Show(E.ToString());
            }
        }

        private void BTN_Write_Click_1(object sender, EventArgs e)
        {
            try
            {
                short DBNr = Convert.ToInt16(TB_DBNr_Read.Text);
                short Count = Convert.ToInt16(TB_Count_Read.Text);
                int Start = Convert.ToInt32(TB_StartAddress_Read.Text);

                switch (CB_DataType_Read.Text)
                {
                    case "BYTE":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new byte[] { Convert.ToByte(TB_Value.Text) });
                        break;
                    case "WORD":
                    case "DATE":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new UInt16[] { Convert.ToUInt16(TB_Value.Text) });
                        break;
                    case "INT":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new Int16[] { Convert.ToInt16(TB_Value.Text) });
                        break;
                    case "REAL":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new float[] { float.Parse(TB_Value.Text) });
                        break;
                    case "DWORD":
                    case "TIME_OF_DAY":
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, new UInt32[] { Convert.ToUInt32(TB_Value.Text) });
                        break;
                    case "S5TIME":
                        S7Connector.S5Time[] s5Times = new S7Connector.S5Time[2];
                        s5Times[0] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 10, 0));
                        s5Times[1] = new S7Connector.S5Time(new TimeSpan(0, 0, 0, 11, 0));
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s5Times);
                        break;
                    case "TIMEIEC32":
                        S7Connector.TimeIEC32[] s7Times = new S7Connector.TimeIEC32[1];
                        s7Times[0] = new S7Connector.TimeIEC32(new TimeSpan(0, 0, 2, 1, 100));
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s7Times);
                        break;
                    case "COUNTER":
                        S7Connector.Counter[] s7Conter = new S7Connector.Counter[1];
                        s7Conter[0] = new S7Connector.Counter(Convert.ToInt16(TB_Value.Text));
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, s7Conter);
                        break;
                    case "BOOL":
                        bool Val = false;
                        if (TB_Value.Text.ToLower() == "true")
                            Val = true;
                        SPS.AG_Write(DBNr, Start, Read_Selected_MemmoryType, Val);
                        break;
                }
            }
            catch (Exception E)
            {
                MessageBox.Show(E.ToString());
            }
        }

        private void CB_SPS_Type_TCP_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            //TCP_Selected_SPSType = (S7Connector.TypeSeries)CB_SPS_Type_TCP.SelectedValue;
        }

        private void CB_MemmoryType_Read_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            //Read_Selected_MemmoryType = (S7Connector.MemmoryTypes)CB_MemmoryType_Read.SelectedValue;

            //if (CB_MemmoryType_Read.SelectedIndex == 0)
            //{
            //    TB_DBNr_Read.Enabled = true;
            //}
            //else
            //{
            //    TB_DBNr_Read.Text = "0";
            //    TB_DBNr_Read.Enabled = false;
            //}
        }

        private void CB_DataType_Read_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            //Read_Selected_DataType = (S7Connector.DataTypes)CB_DataType_Read.SelectedValue;
        }
    }
}