﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace Ro.CF.Communication
{
    [Guid("6e540092-f87d-465d-9885-6ef1b27be27d")]
    public interface IS7Connector_ComInterop
    {
        void TCPIP(int Tzeit, string CP_IP, string TsapE, string TsapF);
        void Set_Licence(string Licence);
        object ag_Read(string DBNr, string anzby, string startad, string Datenart, string Spsart);
        bool ag_WriteS(string db, string startad, string wert, string Spsart);
        bool ag_WriteB(string db, string startad, string wert, string Spsart);
        bool ag_WriteW(string db, string startad, string wert, string Spsart);
        bool ag_WriteF(string db, string startad, string wert, string Spsart);
        bool ag_WriteX(string db, string startad, string wert, string Spsart, string Bitadd);
    }

    [Guid("07ccd5e4-132f-42c7-bacf-08da81cdba14")]
    public class S7Connector_ComInterop : IS7Connector_ComInterop
    {
        public bool inuse = false;
        public int err = 0;

        private Ro.CF.Communication.S7Connector.Base SPS;

        public S7Connector_ComInterop()
        {

        }

        public void TCPIP(int Tzeit, string CP_IP, string TsapE, string TsapF)
        {
            SPS = new Ro.CF.Communication.S7Connector.TCPIP(CP_IP, 102, Tzeit, TsapE, TsapF);
        }

        public void Set_Licence(string Licence)
        {
            Ro.CF.Communication.S7Connector.Licence = Licence;
        }

        public object ag_Read(string DBNr, string anzby, string startad, string Datenart, string Spsart)
        {
            inuse = true;
            Ro.CF.Communication.S7Connector.DataTypes DT = Ro.CF.Communication.S7Connector.DataTypes.BYTE;
            Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
            switch (Datenart)
            {
                case "B":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.BYTE;
                    break;
                case "C":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.CHAR;
                    break;
                case "D":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.DWORD;
                    break;
                case "F":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.REAL;
                    break;
                case "I":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.INT;
                    break;
                case "W":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.WORD;
                    break;
                case "X":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.BOOL;
                    break;
                case "T":
                    DT = Ro.CF.Communication.S7Connector.DataTypes.S5TIME;
                    break;
            }
            switch (Spsart)
            {
                case "A":
                    MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                    break;
                case "D":
                    MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                    break;
                case "E":
                    MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                    break;
                case "M":
                    MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                    break;
            }
            object RetObj = SPS.AG_Read(Convert.ToInt16(DBNr), Convert.ToInt32(startad), Convert.ToInt16(anzby), DT, MT);
            inuse = false;
            return RetObj;
        }

        public bool ag_WriteS(string db, string startad, string wert, string Spsart)
        {
            bool RetVal = true;
            try
            {
                inuse = true;
                Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                switch (Spsart)
                {
                    case "A":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                        break;
                    case "D":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                        break;
                    case "E":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                        break;
                    case "M":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                        break;
                }

                SPS.AG_Write(Convert.ToInt16(db), Convert.ToInt32(startad), MT, Encoding.Default.GetBytes(wert));
                inuse = false;
            }
            catch (Exception)
            {
                inuse = false;
                RetVal = false;
            }

            return RetVal;
        }

        public bool ag_WriteB(string db, string startad, string wert, string Spsart)
        {
            bool RetVal = true;
            try
            {
                inuse = true;
                Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                switch (Spsart)
                {
                    case "A":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                        break;
                    case "D":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                        break;
                    case "E":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                        break;
                    case "M":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                        break;
                }

                SPS.AG_Write(Convert.ToInt16(db), Convert.ToInt32(startad), MT, new byte[] { Convert.ToByte(wert) });
                inuse = false;
            }
            catch (Exception)
            {
                inuse = false;
                RetVal = false;
            }

            return RetVal;
        }

        public bool ag_WriteW(string db, string startad, string wert, string Spsart)
        {
            bool RetVal = true;
            try
            {
                inuse = true;
                Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                switch (Spsart)
                {
                    case "A":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                        break;
                    case "D":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                        break;
                    case "E":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                        break;
                    case "M":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                        break;
                }

                SPS.AG_Write(Convert.ToInt16(db), Convert.ToInt32(startad), MT, new short[] { Convert.ToInt16(wert) });
                inuse = false;
            }
            catch (Exception)
            {
                inuse = false;
                RetVal = false;
            }

            return RetVal;
        }

        public bool ag_WriteF(string db, string startad, string wert, string Spsart)
        {
            bool RetVal = true;
            try
            {
                inuse = true;
                Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                switch (Spsart)
                {
                    case "A":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                        break;
                    case "D":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                        break;
                    case "E":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                        break;
                    case "M":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                        break;
                }
                SPS.AG_Write(Convert.ToInt16(db), Convert.ToInt32(startad), MT, new float[] { float.Parse(wert) });
                inuse = false;
            }
            catch (Exception)
            {
                inuse = false;
                RetVal = false;
            }

            return RetVal;
        }

        public bool ag_WriteX(string db, string startad, string wert, string Spsart, string Bitadd)
        {
            bool RetVal = true;
            try
            {
                inuse = true;
                Ro.CF.Communication.S7Connector.MemmoryTypes MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                switch (Spsart)
                {
                    case "A":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Output;
                        break;
                    case "D":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Datablock;
                        break;
                    case "E":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Input;
                        break;
                    case "M":
                        MT = Ro.CF.Communication.S7Connector.MemmoryTypes.Flag;
                        break;
                }

                SPS.AG_Write(Convert.ToInt16(db), ((Convert.ToInt32(startad) * 8) + Convert.ToInt32(Bitadd)), MT, ((wert == "1") || (wert.ToLower() == "true")));
                inuse = false;
            }
            catch (Exception)
            {
                inuse = false;
                RetVal = false;
            }

            return RetVal;
        }

    }
}
